/****
	reentrant_newcpu.c
 ****/

#include "sysconfig.h"
#include "sysdeps.h"

#include "config.h"
#include "options.h"
#include "machdep/m68k.h"

#include "memory.h"

#include "Memory.h"
#include "custom.h"
#include "reentrant_newcpu.h"
#include "../Unix/universal.h"

#include "readcpu.h"
#include "newcpu.h"
#include "debug.h"
#include "compiler.h"

#include "VIA_Interrupts.h"
#include "Native.h"

void step_m68k_run_1(void)
{
ULONG program_counter;
UWORD opcode;

	program_counter = m68k_getpc();
	opcode = nextiword();

#if COUNT_INSTRS
	instrcount[opcode]++;
#endif

/*
#if defined(X86_ASSEMBLY)
	__asm__ __volatile__("\tcall *%%ebx"
			     : : "b" (cpufunctbl[opcode]), "a" (opcode)
			     : "%eax", "%ebx", "%edx", "%ecx", 
			     "%esi", "%edi", "%ebp", "memory", "cc");
#else
*/
	(*cpufunctbl[opcode])(opcode);
//#endif

#ifndef NO_EXCEPTION_3
	if (buserr) {
	    last_op_for_exception_3 = opcode;
	    Exception(3,0);
	    buserr = 0;
	}
#endif

	if (regs.spcflags) {
	    while (regs.spcflags & SPCFLAG_BLTNASTY) {
		if (regs.spcflags & SPCFLAG_DISK)
		   empty();
	    }
	    run_compiled_code();
	    if (regs.spcflags & SPCFLAG_DOTRACE) {
		Exception(9,last_trace_ad);
	    }
	    while (regs.spcflags & SPCFLAG_STOP) {
		if (regs.spcflags & SPCFLAG_DISK)
			empty();
		if (regs.spcflags & (SPCFLAG_INT | SPCFLAG_DOINT)){
		    int intr = intlev();
		    regs.spcflags &= ~(SPCFLAG_INT | SPCFLAG_DOINT);
		    if (intr != -1 && intr > regs.intmask) {
			Interrupt(intr);
			regs.stopped = 0;
			regs.spcflags &= ~SPCFLAG_STOP;
		    }
		}
	    }
	    do_trace();

	    if (regs.spcflags & SPCFLAG_DISK)
		empty();

	    if (regs.spcflags & SPCFLAG_DOINT) {
		int intr = intlev();
		regs.spcflags &= ~SPCFLAG_DOINT;
		if (intr != -1 && intr > regs.intmask) {
		    Interrupt(intr);
		    regs.stopped = 0;
		}	    
	    }
	    if (regs.spcflags & SPCFLAG_INT) {
		regs.spcflags &= ~SPCFLAG_INT;
		regs.spcflags |= SPCFLAG_DOINT;
	    }
	    if (regs.spcflags & (SPCFLAG_BRK|SPCFLAG_MODE_CHANGE)) {
		regs.spcflags &= ~(SPCFLAG_BRK|SPCFLAG_MODE_CHANGE);
		return;
	    }
	}
}
/*
#ifdef X86_ASSEMBLY
static __inline__ void step_m68k_run1(void)
{
*/
    /* Work around compiler bug: GCC doesn't push %ebp in m68k_run_1. */
/*
    __asm__ __volatile__ ("pushl %%ebp\n\tcall *%%eax\n\tpopl %%ebp" : : "a" (step_m68k_run_1) : "%eax", "%edx", "%ecx", "memory", "cc");
}
#else
*/
#define step_m68k_run1 step_m68k_run_1
//#endif

void reentrant_m68k_step(void)
{
	step_m68k_run1();
}

