

#define kPrinterDirectOpCode    20

#define kPDOpenSelect           1
#define kPDSendDataSelect       2
#define kPDSendFileSelect       3
#define kPDCloseSelect          4
#define kPDDespoolSelect        5
#define kPDVerifySelect         6

#define kPDNoData               0
#define kPDData                 1
#define kPDFileSpec             2

enum {
        pdBadSelectorErr        = -10001,
        pdBadSendModeErr        = -10002,
        pdBadJobIDErr           = -10003,
        pdDespoolFailed         = -10004
};

Data Types

struct OpenPDBlk {
        SInt16 opCode;          // Printer Direct opCode = 20
        OSErr error;            // Result code
        UInt32 reserved;        // reserved
        UInt32 selector;        // Function selector code
        UInt32 jobID;           // ID referencing this job
        UInt32 spoolType;       // Ptr to data or FSSpec.
};
typedef struct OpenPDBlk OpenPDBlk, *OpenPDBlkPtr;


struct SendPDDataBlk {
        SInt16 opCode;          // Printer Direct opCode = 20
        OSErr error;            // Result code
        UInt32 reserved;        // reserved
        UInt32 selector;        // Function selector code
        UInt32 jobID;           // ID referencing this job
        Ptr Data;               // Pointer to the data.
        UInt32 count;           // Number of bytes Data points to.
};
typedef struct SendPDDataBlk SendPDDataBlk, *SendPDDataBlkPtr;


struct SendPDFileSpecBlk {
        SInt16 opCode;          // Printer Direct opCode = 20
        OSErr error;            // Result code
        UInt32 reserved;        // reserved
        UInt32 selector;        // Function selector code
        UInt32 jobID;           // ID referencing this job
        FSSpec fileSpec;        // Points to file where data is
};
typedef struct SendPDFileSpecBlk SendPDFileSpecBlk, *SendPDFileSpecBlkPtr;


struct ClosePDBlk {
        SInt16 opCode;          // Printer Direct opCode = 20
        OSErr error;            // Result code
        UInt32 reserved;        // reserved
        UInt32 selector;        // Function selector code
        UInt32 jobID;           // ID referencing this job
};
typedef struct ClosePDBlk ClosePDBlk, *ClosePDBlkPtr;


struct DespoolPDBlk {
        SInt16 opCode;                  // Printer Direct opCode = 20
        OSErr error;                    // Result code
        UInt32 reserved;                // reserved
        UInt32 selector;                // Function selector code
        UInt32 jobID;                   // ID referencing this job
        UniversalProcPtr idleProcPtr;   // idleProc
};
typedef struct DespoolPDBlk DespoolPDBlk, *DespoolPDBlkPtr;


struct VerifyPDBlk {
        SInt16 opCode;                  // Printer Direct opCode = 20
        OSErr error;                    // Result code
        UInt32 reserved;                // reserved
        UInt32 selector;                // Function selector code
        OSType drvrCreator;             // Printer driver's creator type
        NumVersion drvrVersion;         // Printer driver's version number
};
typedef struct VerifyPDBlk VerifyPDBlk, *VerifyPDBlkPtr;


