/* vMac 0.1 Source
   By Philip Cummins (PC)
   Copyright PC 1997 */

/* PC - Interrupt Functions */

#include "sysconfig.h"
#include "sysdeps.h"
#include "config.h"
#include "custom.h"
#include "VIA.h"
#include "VIA_Interrupts.h"
#include "VIA_Interface.h"
#include "Screen.h"
#include "RTC.h"
#include "Sound.h"
#include "Mouse.h"
#include "Native.h"
#include "Sony.h"
#include "debug.h"
#include "prefs.h"
#include "Unix/universal.h"

#include <sys/time.h>

unsigned long int Instruction_Counter = 0;
int VBL_Counter = 0;
static long int Mouse_Counter = 0;
static int VIA_Counter = 0;
static long int ClockTick = 0;
static long int OldClockTick = 0;

int Interrupt_Init (void)
{
  Instruction_Counter = 0;
  VIA_Counter = 0;
  Mouse_Counter = 0;
  VBL_Counter = 0;
  return 0;
}

void Interrupt_Reset (void)
{
  (void) Interrupt_Init();
}

__inline__ void Interrupt_Timing (void)
{

  // Clock = 7833600 Hz (7.8336 mHz)
  // At best, we can get 3916800 instructions per second
  // Normally, it's probably a lot lower than that, say
  // 783360 instructions/sec if there's 10 cycles per instr.
  
  if (++VIA_Counter == 0)
  {
    VIA_Counter = 0;
    VIA_Timer();
  }

  if (++Instruction_Counter == thePrefs.NumInstructions)
  {
    Screen_Draw();
    Process_Screen_Events();
    Mouse_Update2();

    Instruction_Counter = 0;
    VBL_Counter = 1;
    VIA_Int(Vertical_Blanking);

    // Michael's little 1-sec interrupt. It works -- kinda.
    // If you have any hints, let me know!
   
    ClockTick = clock();
  
    if (ClockTick >= OldClockTick + (CLOCKS_PER_SEC - 2))
    {
      VBL_Counter = 60;
      OldClockTick = ClockTick;
    }
    else
    {
      VBL_Counter = 1;
    }

    if (VBL_Counter == 60)
    {
      VBL_Counter = 0;
      Sony_Update();
      RTC_Interrupt();
      VIA_Int(One_Second);
    }
  }
}

