#import "MacTimer.h"

#define ACTIVE_FPS   (15) // 15 frame per sec
#define INACTIVE_FPS (1)  //  1 frame per sec

@implementation MacTimer

- init
{
    float dt = 1.0 / (float)ACTIVE_FPS;
    [super init:dt target:macView action:@selector(display)];
    activefps = ACTIVE_FPS;
    return self;
}

- suspend
{
    if( timerflag )
    {
        [super stopTimer];
        [super changeInterval:(1.0 / (float)INACTIVE_FPS)];
        [super startTimer];
        active = NO;
    }
    return self;
}

- resume
{
    if( timerflag )
    {
        [super stopTimer];
        [super changeInterval:(1.0 / (float)activefps)];
        [super startTimer];
        active = YES;
    }
    return self;
}

- setActiveInterval:(int)rate
{
    activefps = rate;
    if( timerflag && active )
    {
        [self resume];
    }
    return self;
}

@end

