
#import "PrefController.h"

@implementation PrefController

+ initialize
{
    if( self == [PrefController class] )
    {
        const char *appName = [NXApp appName];
        static NXDefaultsVector theDefaults =
        {
            {"RAMSize",     "2"},
            {"SystemDisk",  "System6.dsk"},
            {"RefreshRate", "15"},
            {"ClockRate",   "1.0"},
            {NULL, NULL}
        };
        NXRegisterDefaults( appName, theDefaults );
    }
    return self;
}

- revertPreferences:sender
{
    const char *appName = [NXApp appName];
    
	[ramSize selectCellWithTag:(atoi(NXGetDefaultValue(appName,"RAMSize")))];
    [systemDiskField setStringValue:NXGetDefaultValue(appName, "SystemDisk")];
    [refreshRateField setIntValue:(atoi(NXGetDefaultValue(appName, "RefreshRate")))];
    [refreshRateSlider setIntValue:(atoi(NXGetDefaultValue(appName, "RefreshRate")))];
    [clockRateField setFloatValue:(atof(NXGetDefaultValue(appName, "ClockRate")))];
    [clockRateSlider setFloatValue:(atof(NXGetDefaultValue(appName, "ClockRate")))];
    return self;
}

- setPreferences:sender
{
    const char *appName = [NXApp appName];
	char 	buf[256];
    static NXDefaultsVector newDefaults =
    {
        {"RAMSize",     ""}, /* 0 */
        {"SystemDisk",  ""}, /* 1 */
        {"RefreshRate", ""}, /* 2 */
        {"ClockRate",   ""}, /* 3 */
        {NULL, NULL}
    };
	
    // ǥեȤ¸
	sprintf(buf,"%d", [[ramSize selectedCell] tag]);
	newDefaults[0].value = alloca(256);
	strcpy(newDefaults[0].value, buf);
	
	sprintf(buf,"%s", [systemDiskField stringValue]);
	newDefaults[1].value = alloca(256);
	strcpy(newDefaults[1].value, buf);
	
	sprintf(buf,"%d", [refreshRateField intValue]);
	newDefaults[2].value = alloca(256);
	strcpy(newDefaults[2].value, buf);
	
	sprintf(buf,"%f", [clockRateField floatValue]);
	newDefaults[3].value = alloca(256);
	strcpy(newDefaults[3].value, buf);

	NXWriteDefaults(appName, newDefaults);

    // ǥեȤѤä򥳥ȥϢ
    [controller changePreferences];
    
    return self;
}

- awakeFromNib
{
    [self revertPreferences:nil];
	return self;
}

- (int)ramSize
{
    int r = 0;
    switch([[ramSize selectedCell] tag])
    {
    case 0:
        r = 1;
        break;
    case 1:
        r = 2;
        break;
    case 2:
        r = 4;
        break;
    }
    return r;
}

- (char *)systemDisk
{
    return [systemDiskField stringValue];
}

- (int)refreshRate
{
    return [refreshRateField intValue];
}

- (float)clockRate
{
    return [clockRateField floatValue];
}

- setSystemDisk:sender
{
    char *path;
    const char *const types[] = {"dsk","hfv", NULL};
    id openPanel = [OpenPanel new];

    [openPanel allowMultipleFiles:NO];
    path = alloca(1 + MAXPATHLEN);

    if ([openPanel runModalForDirectory:path file:NULL types:types])
    {
        const char *file = [openPanel filename];
        if( file != NULL)
        {
            [systemDiskField setStringValue:file];
        }
    }
    return self;
}

@end
