#import "Timer.h"

@implementation Timer

void timefunc(DPSTimedEntry teNumber, double now, id self)
{
    [self->target perform:self->action with:self];
}

- init:(double)dt target:(id)aTarget action:(SEL)anAction
{
    [super init];
    interval = dt;
    target = aTarget;
    action = anAction;
    timerflag = NO;
    return self;
}

- free
{
    if( timerflag )
    {
        DPSRemoveTimedEntry(te);
    }
    return [super free];
}

- startTimer
{
    if( !timerflag )
    {
        te = DPSAddTimedEntry(interval, &timefunc, self, NX_BASETHRESHOLD);
    }
    timerflag = YES;
    return self;
}

- stopTimer
{
    if( timerflag )
    {
        DPSRemoveTimedEntry(te);
    }
    timerflag = NO;
    return self;
}

- changeInterval:(double)dt
{
    interval = dt;
    [[self stopTimer] startTimer];
}

@end

