#import <appkit/appkit.h>
#import "MacView.h"

#define EXTERN
#import "global.h"

//
// used from vMacController
//

volatile int thread_condition;
mutex_t conditionLock;
condition_t done, resume, suspended;

static unsigned short drivetag;
static char *loadfile = NULL;

void Process_Screen_Events(void)
{
    switch(thread_condition)
    {
    case CTHREAD_RESET:
        m68k_reset();
        mutex_lock(conditionLock);
        thread_condition = CTHREAD_NORMAL;
        mutex_unlock(conditionLock);
        break;
    case CTHREAD_QUIT:
        condition_signal(done);
        cthread_exit(0);
        break;
    case CTHREAD_STOP:
        condition_signal(suspended);
        mutex_lock(conditionLock);
        condition_wait(resume, conditionLock);
        mutex_unlock(conditionLock);
        break;
    default:
        if( loadfile != NULL )
        {
            Sony_Insert(drivetag, (char *)loadfile);
            free(loadfile);
            loadfile = NULL;
        }
        break;
    }
}

void diskInsert(unsigned short tag, const char *filename)
{
    loadfile = NULL;
    if( filename != NULL )
    {
        drivetag = tag;
        if( loadfile != NULL )
        {
            free(loadfile);
        }
        loadfile = malloc(strlen(filename) + 1);
        strcpy(loadfile, filename);
    }
}

//
// used from MacView
//

const int macDisplayHeight = 342;
const int macDisplayWidth  = 512;
int lastmx, lastmy;
int buttonstate;
UBYTE vPage2 = 1;
id theMacView;

void Screen_Draw()
{
    return;
}

void Screen_Reset()
{
    return;
}

// VIA Interface Functions
UBYTE VIA_GORA6 (void)
{
    return 0;
}

void VIA_PORA6(UBYTE Data)
{
    vPage2 = Data;
}

UBYTE VIA_GORB6(void) // Video Beam in Display
{
    return 0;
}

void VIA_PORB6(UBYTE Data)
{
    return;
}

//
// used from other files
//

void Show_Version(void)
{
    return;
}

void Quit_vMac(void)
{
    exit(0);
}
