 /*
  * vMac DSP Sound Interface
  * Copyright 1997 Michael Hanni (mhanni@sprintmail.com)
  */

/*
	WARNING!! This currently DOES NOT work! You can try it, but you won't
	get anything but weird noises.
*/

#include "sysconfig.h"
#include "sysdeps.h"

#include "config.h"
#include "options.h"
#include "memory.h"
#include "custom.h"
#include "Sound.h"
#include "RAM.h"
#include "prefs.h"

#include <unistd.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/ioctl.h>
#include <stdlib.h>
#include <stdio.h>
#include <sys/soundcard.h>
#include <sys/time.h>
#include <signal.h>


//#define RATE		22254
//#define RATE		44511
#define RATE		65536
#define SIZE		8

// Local Variables

Sound_Ty Sound;

int AudioDev;
int	fd, arg, status;
static unsigned long formats;

int Audio_Init(void)
{

   if (thePrefs.Sound == 1)
   {
	int format;
	
	printf("vMac: Sound enabled. (buggy and bad.)\n");

	fd = open("/dev/dsp", O_RDWR);
	if (fd < 0) {
		perror("open of /dev/dsp failed.\n");
		exit(1);
	}

    	ioctl (fd, SNDCTL_DSP_GETBLKSIZE, 740);

	arg = SIZE;
	ioctl(fd, SNDCTL_DSP_SAMPLESIZE, &arg);
	ioctl(fd, SOUND_PCM_READ_BITS, &arg);

    	arg = 0;
    	ioctl(fd, SNDCTL_DSP_STEREO, &arg);

    	arg = RATE;
    	ioctl (fd, SNDCTL_DSP_SPEED, &arg);
    	ioctl (fd, SOUND_PCM_READ_RATE, &arg);  

	format = AFMT_U8;
	if (ioctl(fd, SNDCTL_DSP_SETFMT, &format) == -1)
		printf("Error, in SETFMT");
	
	ioctl(fd, SNDCTL_DSP_GETBLKSIZE, 740);

	Sound.Enable = 0;

   }
   else {
	printf("vMac: Sound disabled.\n");
   }

   return 0;

}
                                                                    
int Audio_Close(void)
{
	close(fd);
	return 0;
}

__inline__ void Audio_Update(void)
{
  if(thePrefs.Sound == 1) {
   if (Sound.Enable == 0) {

      ULONG kSound_Address;
      UBYTE Sound_Buffer[740];
//      UWORD Sound_Buffer[370];
      int pos;
      int n;

      if (Sound.Buffer==0) {
	kSound_Address = kSnd_Alt_Buffer;
      } else {
	kSound_Address = kSnd_Main_Buffer;
      }

      for (pos = 0 ; pos < 740 ; pos++) {
	Sound_Buffer[pos] = ((RAM_GetW(kSound_Address+pos) & 0xFF00) >> 8);
      }

      for (pos=0 ; pos < 370 ; pos++) {
	Sound_Buffer[pos] = ((RAM_GetW(kSound_Address+pos) & 0xFF00) >> 8);
      }

//printf("%d\n", sizeof(Sound_Buffer));

      write(fd, Sound_Buffer, sizeof(Sound_Buffer));
   }
  }

}

// VIA Interface Functions

UBYTE VIA_GORA3 (void) // Main/Alternate Sound Buffer
{
#	ifdef _VIA_Interface_Debug
  printf("VIA ORA3 attempts to be an input\n");
#	endif
  return 0;
}

void  VIA_PORA3 (UBYTE Data)
{
  Sound.Buffer = Data; // 1 = Main, 0 = Alternate
}

UBYTE VIA_GORA2 (void) // Sound Volume Bit 2
{
#	ifdef _VIA_Interface_Debug
  printf("VIA ORA2 attempts to be an input\n");
#	endif
  return 0;
}

void  VIA_PORA2 (UBYTE Data)
{
  if (Data == 0)
    { Sound.Volume &= 0x03; }
  else
    { Sound.Volume |= 0x04; }
}

UBYTE VIA_GORA1 (void) // Sound Volume Bit 1
{
#	ifdef _VIA_Interface_Debug
  printf("VIA ORA1 attempts to be an input\n");
#	endif
  return 0;
}

void  VIA_PORA1 (UBYTE Data)
{
  if (Data == 0)
    { Sound.Volume &= 0x05; }
  else
    { Sound.Volume |= 0x02; }
}

UBYTE VIA_GORA0 (void) // Sound Volume Bit 0
{
  #ifdef _VIA_Interface_Debug
  printf("VIA ORA0 attempts to be an input\n");
  #endif
  return 0;
}

void  VIA_PORA0 (UBYTE Data)
{
  if (Data == 0)
    { Sound.Volume &= 0x06; }
  else
    { Sound.Volume |= 0x01; }
}

UBYTE VIA_GORB7 (void) // Sound Enable
{
  #ifdef _VIA_Interface_Debug
  printf("VIA ORB7 attempts to be an input\n");
  #endif
  return 0;
}

void  VIA_PORB7 (UBYTE Data)
{
  Sound.Enable = Data; // 0 = Enabled, 1 = Disabled
}
