 /* 
  * UAE - The Un*x Amiga Emulator
  * 
  * User configuration options
  *
  * Copyright 1995, 1996 Bernd Schmidt
  */

/* vMac Configurations */

#define VMACVERSION "0.1.9.3"

// These are debug flags, you really don't need them.

#undef _Debug

#ifdef _Debug
#define _SCC_Debug
//#define _IWM_Debug
//#define _Keyboard_Debug
//#define _Memory_Debug
//#define _Mouse_Debug
//#define _Native_Debug
//#define _RAM_Debug
//#define _ROM_Debug
//#define _RTC_Debug
//#define _Screen_Debug
//#define _SCSI_Debug
//#define _Sony_Debug
//#define _Sound_Debug
//#define _VIA_Debug
//#define _VIA_Interface_Debug
//#define _VIA_Interrupt_Debug
#endif

#define _Sony_Enabled
#define _Mouse_Enabled
#define _Keyboard_Enabled

/*
 * CPU level: 0 = 68000, 1 = 68010, 2 = 68020, 3 = 68020/68881
 * If configured for 68020, the emulator will be a little slower.
 */
#define CPU_LEVEL 0

/* YOU REALLY SHOULD NOT TOUCH ANY OF THESE DEFINES BELOW THIS POINT 
   DOING SO WILL MAKE vMac BREAK HORRIBLY! */

/*
 * With this parameter, you can tune the CPU speed vs. graphics/sound hardware
 * speed. If you set this to 1, you'll get maximum CPU speed, but demos and
 * games will run very slowly. With large values, the CPU can't execute many
 * instructions per frame, but for many demos, it doesn't have to. A good
 * compromise is setting this to 4. Higher values may produce better sound
 * output, but can make some programs crash because they don't get enough CPU
 * time.
 *
 * M68K_SPEED should be set to 4 in all binary versions that are distributed.
 *
 * 1. A fast one: no sound compiled in, NO_EXCEPTION_3 and NO_PREFETCH_BUFFER
 * 2. A slightly slower one: as above, but with sound compiled in
 * 3. A dog slow but compatible one: sound, exception 3 and prefetch emulated.
 *
 */
#define M68K_SPEED 4

/*
 * Unfortunately, there are people who think it's way k00l to play stupid
 * tricks with the MC68000, the CPU of the Amiga. Enable this option to
 * emulate the prefetch buffer. You don't have to know what a prefetch buffer
 * is, you should know however that it's needed for better compatibility and
 * that emulating it makes the emulator somewhat slower.
 */
#define NO_PREFETCH_BUFFER

/*
 * Some STUPID programs access a longword at an odd address and expect to
 * end up at the routine given in the vector for exception 3.
 * (For example, Katakis does this). And yes, I know it's legal, but it's dumb
 * anyway.
 * If you leave this commented in, memory accesses will be faster,
 * but some programs may fail for an obscure reason.
 */
#define NO_EXCEPTION_3

/*
 * This variable was introduced because a program could do a Bcc from
 * whithin chip memory to a location whitin expansion memory. With a
 * pointer variable the program counter would point to the wrong location.
 * With this variable unset the program counter is always correct, but
 * programs will run slower (about 4%).
 * Usually, you'll want to have this defined.
 *
 * vMac REQUIRES this. It allows for fun things like Restart.
 *
 */
#define USE_POINTER

//IRIX CC needs a little new-line at the end of include files.

