/* vMac 0.1 Source
   By Philip Cummins (PC)
   Copyright PC 1997 */
   
/* vMac Custom Code */

#include <ctype.h>
#include <assert.h>

#include "sysconfig.h"
#include "sysdeps.h"
#include "config.h"
#include "options.h"

#include "custom.h"

#include "CPU/machdep/m68k.h"
#include "Memory.h"
#include "memory.h"

#include "readcpu.h"
#include "newcpu.h"

#include "IWM.h"
#include "RAM.h"
#include "ROM.h"
#include "RTC.h"
#include "SCC.h"
#include "SCSI.h"
#include "Screen.h"
#include "Sony.h"
#include "Sound.h"
#include "VIA.h"
#include "VIA_Interrupts.h"

unsigned long specialflags = 0;
int InterruptNo = -1;

void MacInterrupt (void)
{	   
//specialflags |= SPCFLAG_DOINT;
//InterruptNo = 4;
//  if (regs.intmask <= 4)
//
// bill comment ---
//
// This statement below could be problematic
// because I took a educated guess for the
// value of the second parameter...
//
    Exception(28,0);
}

void MacReset (void)
{
  m68k_reset();
}

int custominit (void)
{
  int Err = 0;
//  Err += Audio_Init();
  Err += RAM_Init();
  Err += ROM_Init();
  Err += IWM_Init();
  Err += SCC_Init();
  Err += SCSI_Init();
  Err += VIA_Init();
  Err += RTC_Init();
  Err += Memory_Init();
//  Err += Screen_Init();
  Err += Interrupt_Init();
  Err += Sony_Init();
  InterruptNo = -1;
  return Err;
}

void customreset (void)
{
  RAM_Reset();
  ROM_Reset();
  IWM_Reset();
  SCC_Reset();
  SCSI_Reset();
  VIA_Reset();
  RTC_Reset();
  Memory_Init();
  Screen_Reset();
  Interrupt_Reset();
  Sony_Reset();
  InterruptNo = -1;
}

UWORD   intena = 0,
        intreq = 0,
        dmacon;

int intlev(void)
{
    UWORD imask = intreq & intena;
    if (imask && (intena & 0x4000)){
        if (imask & 0x2000) return 6;
        if (imask & 0x1800) return 5;
        if (imask & 0x0780) return 4;
        if (imask & 0x0070) return 3;
        if (imask & 0x0008) return 2;
        if (imask & 0x0007) return 1;
    }
    return -1;
}

