/* vMac 0.1 Source
   By Philip Cummins (PC)
   Copyright PC 1997 */
   

#include "sysconfig.h"
#include "sysdeps.h"
#include "config.h"
#include "options.h"

#include "prefs.h"
#include "memory.h"

#include "custom.h"
#include "readcpu.h"
#include "newcpu.h"
#include "debug.h"

#include "Memory.h"
#include "Sony.h"
#include "Screen.h"


int use_debugger = 0;

void Quit_vMac(void);
void Show_Version(void);

void Show_Version(void)
{
        printf("vMac %s for Unix X Window Systems.\n", VMACVERSION);
        printf("by Michael Hanni (mhanni@sprintmail.com)\n");
        printf("Version 0.1.9.3 released by Weston Pawlowski\n");
}

void Quit_vMac(void)
{
	PrefsSave(".vmacrc");
	 
	vMac_Uninstall_SignalHandler();
	
	fprintf(stderr, "vMac: vMac quit successful, .vmacrc saved.\n");

	exit(0);
}

int main(int argc, char **argv)
{

	PrefsLoad(".vmacrc");

        if (argc > 1)
        {
                if (strcasecmp(argv[1], "-v") == 0)
                {
                        Show_Version();
                        exit(0);
                }
        }

	vMac_Install_SignalHandler();

	init_m68k();

	if (custominit() == 0)
	{

		Screen_Init(argc, argv);

		m68k_reset();
		m68k_go(1); // for UAE 0.69 bill comment---
	}
	else
	{
		printf("Sorry, vMac encountered errors and cannot continue.\n");
	}
	
	PrefsSave(".vmacrc");

	return (0);
}

