// Cross Platform Compatible Preferences Code for vMac
// (C) 1997 Richard Bannister

// Based on code from Frodo - (C) 1994-1997 Christian Bauer

#include "sysconfig.h"
#include "sysdeps.h"
#include "prefs.h"

#include <stdio.h>
#include <stdlib.h>

Prefs thePrefs;

char *vMac_File_Setup(char *file)
{
    char *home_return;
    char *home_dir; 
    home_dir = getenv("HOME");
    home_return = malloc (strlen(file) + strlen(home_dir) + 16);

    sprintf(home_return, "%s/%s", home_dir, file);
    return(home_return);
}

void PrefsLoad(char *filename)
{
	FILE *file;
	char *file_to_open;
	char line[256], keyword[256], value[256], val2[256];
	int numvalue = 0;
	int a = 0, b = 0;

	// Initialise the prefs with valid values
        thePrefs.FrameRate=1;
	thePrefs.NoXmouse=0;
	thePrefs.NumInstructions=32640;
	thePrefs.Kanji=0;
	thePrefs.Sound=0;
	strcpy(thePrefs.DrivePath[0], "Disk1.dsk");
	strcpy(thePrefs.DrivePath[1], "Disk2.dsk");
	strcpy(thePrefs.DrivePath[2], "Disk3.dsk");
	strcpy(thePrefs.ROMPath[0],"vMac.ROM");
	thePrefs.CurrentROMPath=0;
	thePrefs.RAMSize=4;
	
	thePrefs.GemulatorBase=0x240;
	thePrefs.GemulatorSocket=0;

	file_to_open = vMac_File_Setup(filename);

	if ((file = fopen(file_to_open, "r")) != NULL)
	{
		while(fgets(line, 255, file))
		{
			//Fixed bug that prevented using spaces in paths - Weston
			
			a=0;
			
			//Get keyword
			for(b=0;a<256;++a,++b)
			{
			    if(line[a]==' ' || line[a]=='\0')
			        break;
			
			    keyword[b]=line[a];
			}
			
			keyword[b]='\0';
			
			++a;
			
			//Get =
			for(;a<256;++a)
			{
			    if(line[a]==' ' || line[a]=='\0')
			        break;
			}
			
			++a;
			
			//Get value
			for(b=0;a<256;++a,++b)
			{
			    if(line[a]=='\n')
			        break;
			
			    value[b]=line[a];
			}
			
			value[b]='\0';
			
			{
                                if (!strcmp(keyword, "FrameRate"))
                                { 
                                        if (!strcmp(value, "1"))
                                                thePrefs.FrameRate = 1;
                                        else if (!strcmp(value, "2"))
                                                thePrefs.FrameRate = 2;
                                        else if (!strcmp(value, "3"))
                                                thePrefs.FrameRate = 3;
                                        else if (!strcmp(value, "4"))
                                                thePrefs.FrameRate = 4;
                                        else if (!strcmp(value, "5"))
                                                thePrefs.FrameRate = 5;
                                        else if (!strcmp(value, "6"))
                                                thePrefs.FrameRate = 6;
                                        else if (!strcmp(value, "7"))
                                                thePrefs.FrameRate = 7;
                                        else if (!strcmp(value, "8"))
                                                thePrefs.FrameRate = 8;
                                        else if (!strcmp(value, "9"))
                                                thePrefs.FrameRate = 9;
                                        else if (!strcmp(value, "10"))
                                                thePrefs.FrameRate = 10;
                                }
				else if (!strcmp(keyword, "RAMSize"))
				{
					if (!strcmp(value, "1"))
						thePrefs.RAMSize = 1;
					else if (!strcmp(value, "2"))
						thePrefs.RAMSize = 2;
					else if (!strcmp(value, "4"))
						thePrefs.RAMSize = 4;
				}
				else if (!strcmp(keyword, "NoXmouse"))
				{
					if (!strcmp(value, "0"))
						thePrefs.NoXmouse = 0;
					else if (!strcmp(value, "1"))
						thePrefs.NoXmouse = 1;
				}  
				else if (!strcmp(keyword, "Kanji"))
				{
					if (!strcmp(value, "0"))
						thePrefs.Kanji = 0;
					else if (!strcmp(value, "1"))
						thePrefs.Kanji = 1;
				}  
				else if (!strcmp(keyword, "NumInstructions"))
				{
					thePrefs.NumInstructions = atoi(value);
				}  
				else if (!strcmp(keyword, "Sound"))
				{
					if (!strcmp(value, "0"))
						thePrefs.Sound = 0;
					else if (!strcmp(value, "1"))
						thePrefs.Sound = 1;
				}  
				else if (!strcmp(keyword, "DrivePath1"))
					strcpy(thePrefs.DrivePath[0], value);
				else if (!strcmp(keyword, "DrivePath2"))
					strcpy(thePrefs.DrivePath[1], value);
				else if (!strcmp(keyword, "DrivePath3"))
					strcpy(thePrefs.DrivePath[2], value);

				else if (!strcmp(keyword, "ROMPath0"))
					strcpy(thePrefs.ROMPath[0],  value);
				else if (!strcmp(keyword, "ROMPath1"))
					strcpy(thePrefs.ROMPath[1],  value);
				else if (!strcmp(keyword, "ROMPath2"))
					strcpy(thePrefs.ROMPath[2],  value);

				else if (!strcmp(keyword, "CurrentROMPath"))
				{
					if (!strcmp(value, "0"))
						thePrefs.CurrentROMPath = 0;
					else if (!strcmp(value, "1"))
						thePrefs.CurrentROMPath = 1;
					else if (!strcmp(value, "2"))
						thePrefs.CurrentROMPath = 2;
						
					else if (!strcmp(value, "G") || !strcmp(value, "g"))
						thePrefs.CurrentROMPath = 255;
				}
				
				else if (!strcmp(keyword, "GemulatorBase"))
				{
					sscanf (value,"%X",&thePrefs.GemulatorBase);
				}	
				else if (!strcmp(keyword, "GemulatorSocket"))
				{
					//Max 7 because length is always 2, so a value of 7 means 7 and 8
					if(atoi(value)>=1 && atoi(value)<=7)
						thePrefs.GemulatorSocket=atoi(value);
				}
			}
		}
		fclose(file);
	}
	free(file_to_open);
}

void PrefsSave(char *filename)
{
	FILE *file;
	char *file_to_save;

	file_to_save = vMac_File_Setup(filename);

	if ((file = fopen(file_to_save, "w")) != NULL) {
		fprintf(file, "// vMac Configuration File\n");
		fprintf(file, "//\n");
		
		fprintf(file, "\n");

                fprintf(file, "// How many frames should be displayed? vMac by default\n");
                fprintf(file, "// draws every frame (1) but on slower machines the\n");
                fprintf(file, "// emulation speed can be adjusted by entering a higher\n");
                fprintf(file, "// figure here. (Minimum value = 1, Maximum Value = 10).\n\n");
		fprintf(file, "// This is only for the SVGALib version of vMac.\n\n");
                fprintf(file, "FrameRate = %d\n\n", thePrefs.FrameRate);

		fprintf(file, "// Amount of instructions per event.\n");
		fprintf(file, "// Fiddling with this number could speed vMac up tremendously\n// on your machine.\n");
		fprintf(file, "// (32460 normally, but anything could work.)\n\n");
		fprintf(file, "NumInstructions = %d\n", thePrefs.NumInstructions);

		fprintf(file, "\n");
		
		fprintf(file, "// Do you want to turn of the X cursor in the vMac window?\n");
		fprintf(file, "// (1 = yes, 0 = no)\n\n");
		fprintf(file, "NoXmouse = %d\n", thePrefs.NoXmouse);

		fprintf(file, "\n");
		
		fprintf(file, "// Do you want to use Japanese Input? [only System 7,7.1,7.5]\n");
		fprintf(file, "// (1 = yes, 0 = no)\n\n");
		fprintf(file, "Kanji = %d\n", thePrefs.Kanji);

		fprintf(file, "\n");

		fprintf(file, "// Sound (experimental!) only on /dev/dsp Linux machines? (OSS Driver).\n");
		fprintf(file, "// DOES NOT WORK. THIS IS A STUB FOR FUTURE SOUND.\n");
		fprintf(file, "// (1 = yes, 0 = no)\n\n");
		fprintf(file, "Sound = %d\n", thePrefs.Sound);

		fprintf(file, "\n");

		fprintf(file, "// How much RAM do you want the emulated Mac Plus to\n");
		fprintf(file, "// have? (1 = 1 Mb, 2 = 2Mb, 4 = 4Mb).\n\n");
		fprintf(file, "RAMSize = %d\n", thePrefs.RAMSize);

		fprintf(file, "\n");

		fprintf(file, "// Which disks are in the emulated disk drives? Where\n");
		fprintf(file, "// are they located?\n\n");
		fprintf(file, "DrivePath1 = %s\n", thePrefs.DrivePath[0]);
		fprintf(file, "DrivePath2 = %s\n", thePrefs.DrivePath[1]);
		fprintf(file, "DrivePath3 = %s\n", thePrefs.DrivePath[2]);
		
		fprintf(file, "\n");

		fprintf(file, "// And where is the vMac.ROM file? If you have more\n");
		fprintf(file, "// than one you can put in the path for them all and\n");
		fprintf(file, "// vMac will allow you to switch between them!\n\n");
		fprintf(file, "ROMPath0 = %s\n", thePrefs.ROMPath[0]);
		fprintf(file, "ROMPath1 = %s\n", thePrefs.ROMPath[1]);
		fprintf(file, "ROMPath2 = %s\n", thePrefs.ROMPath[2]);

		if(thePrefs.CurrentROMPath==255)
			fprintf(file, "CurrentROMPath = G\n");
		else
			fprintf(file, "CurrentROMPath = %d\n", thePrefs.CurrentROMPath);
		
		fprintf(file, "\n");
		
		fprintf(file, "// vMac also supports Gemulator ROM boards. To\n");
		fprintf(file, "// use a Gemulator ROM board, use G as the value\n");
		fprintf(file, "// for CurrentROMPath and set the Gemulator ROM\n");
		fprintf(file, "// board settings below\n");

		fprintf(file, "\n");

	        fprintf(file, "// What is the base address (in hex) of the Gemulator\n");
        	fprintf(file, "// ROM board? Default is 240. Consult the Gemulator\n");
	        fprintf(file, "// documentation for more information.\n\n");
        	fprintf(file, "GemulatorBase = %X\n", thePrefs.GemulatorBase);

		fprintf(file, "\n");

	        fprintf(file, "// What is the number (1-7) of the first socket on\n");
        	fprintf(file, "// the on the Gemulator ROM board that contains the\n");
	        fprintf(file, "// ROM set that you want to use?  There are 2 ROMs in\n");
        	fprintf(file, "// a MacPlus ROM set, specify the first socket number.\n\n");
	        fprintf(file, "GemulatorSocket = %d\n", thePrefs.GemulatorSocket);
		
		
		fprintf(file, "\n");
		fprintf(file, "// End of File");
		fclose(file);
	}
	free(file_to_save);
}
